/*
 * game.cpp
 *
 *  Created on: 18/mar/2013
 *      Author: utente
 */

#include "Character.h"
#include "Knight.h"
#include "Monster.h"

#include <iostream> // per stampare sullo schermo

int main() {
	Knight hero("Isildur", 12, 6, 7, 7);
	Weapon* sword = new Weapon(6);
	hero.setWeapon(sword);

	Character** enemies = new Character*[3];
	// Enemy 1
	Monster monster1(36, 3, 8);
	Weapon* fang = new Weapon(2);
	monster1.setWeapon(fang);
	enemies[0] = &monster1;
	// Enemy 2
	Knight evilKnight("", 8, 4, 2);
	evilKnight.setWeapon(sword);
	enemies[1] = &evilKnight;
	// Enemy 3 (dynamic allocation)
	Monster* monster2 = new Monster( 24, 2, 2, 1000, 4);
	monster2->setWeapon(fang);
	enemies[2] = monster2;

	// hero gets in the room
	hero.move(3, 4);
	// enemies attack !
	for(int i=0; i< 3; i++) {
		enemies[i]->move(3, 3); // move near hero
		enemies[i]->fight(hero);
	}

	// hero attacks enemy 1
	std::cout << "Monster HPs: " << enemies[0]->getHP() << std::endl;
	int damage = hero.fight(*enemies[0]);
	std::cout << "Damage inflicted: " << damage << std::endl;
	std::cout << "Monster HPs: " << enemies[0]->getHP() << std::endl;
	Weapon* magicSword = new Weapon(8, true);
	hero.setWeapon(magicSword);
	// attack enemy 2
	damage = hero.fight(*enemies[1]);
	std::cout << "Damage inflicted: " << damage << std::endl;
	std::cout << "Monster HPs: " << enemies[1]->getHP() << std::endl;
	if (enemies[1]->getHP() <= 0)
		std::cout << "The monster is dead !" << std::endl;

	std::cout << "Num. characters: " << Character::getNumChar() << std::endl;
	std::cout << "Num. characters: " << hero.getN() << std::endl; // just to compare it with the static method...

	std::cout << hero << std::endl; // calling friend method

	Character charac1(36, 3, 8);
	Character charac1copy(36, 3, 8);
	charac1.setWeapon(fang);
	charac1copy.setWeapon(fang);
	if( charac1 == charac1copy )
		std::cout << "Character are equals !" << std::endl;
	// try to activate one of the following setters to differentiate the characters
	//charac1.setHP(12);
	charac1.setWeapon(sword);
	if( charac1 == charac1copy )
		std::cout << "Character are still equals !" << std::endl;
	else
		std::cout << "Character are now different !" << std::endl;

	delete monster2;
	delete sword;
	delete magicSword;
	delete fang;
}
